﻿using DryIoc.ImTools;
using MySql.Data.MySqlClient;
using StudentManager.Common;
using StudentManager.Data;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace StudentManager.Common
{
	public static class SQLMapping
	{
		public static void Mapping<T>(MySqlDataReader reader)
		{
			typeof(T).GetProperties().ForEach(x => { Debug.WriteLine(x.Name.ToLower()); });
		}

		public static void Mapping<T>(T data, MySqlDataReader reader)
		{
			if (typeof(T) == typeof(StudentData))
			{

				(data as StudentData).UID = (int)reader[0];
				(data as StudentData).Name = reader[1].ToString();
				(data as StudentData).Gender = reader[2].ToString();
				(data as StudentData).Contact = reader[3].ToString();
				(data as StudentData).Address = reader[4].ToString();
				(data as StudentData).Grade = (int)reader[5];
			}
			else
			{

			}



			//for (int i = 0; i < reader.FieldCount; ++i)
			//{
			//	data?.GetType().GetProperties().ForEach(x => { x.SetValue(reader[i].GetType(), reader[i]); });
			//}
		}


	}



	struct userTable
	{

	}

	public static class SQLHelper
	{
		static string config = "server=8.137.125.29;port=3306;user=StudentManager;password=wangxin55;database=studentmanager";
		static MySqlConnection connection = null;
		static MySqlCommand cmd = null;

		// update ** set ** = '**',... where ** = **;
		// insert into ** values('**','**'...);
		// delete from ** where ** = **;
		public static List<T> Query<T>(string tableName, params string[] queryParams) where T : IDataCommon, new()
		{
			connection = new MySqlConnection(config);

			List<T> result = new List<T>();
			try
			{
				connection.Open();
				string queryStr = "";
				if (queryParams.Length > 0)
					queryStr = $"select * from {tableName};";
				else
					queryStr = $"select * from {tableName};";

				cmd = new MySqlCommand(queryStr, connection);
				MySqlDataReader reader = cmd.ExecuteReader();


				T row = new T();

				while (reader.Read())
				{
					SQLMapping.Mapping(row, reader);
					result.Add(row);
				}

				return result;
			}
			catch (Exception ex)
			{
				Console.WriteLine(ex.Message);
				return null;
			}
			finally
			{
				cmd.Dispose();
				connection.Close();
			}
		}

		public static void Add()
		{
			try
			{
			}
			catch (Exception ex)
			{
				Console.WriteLine(ex.Message);
			}
			finally
			{

			}
		}
	}
}
