﻿using StudentManager.Common;
using StudentManager.Data;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace StudentManager.Model
{
	public class Students
	{

		private ObservableCollection<StudentData> studentDatas = new ObservableCollection<StudentData>();
		public ReadOnlyObservableCollection<StudentData> StudentDatas { get; private set; }


		Students()
		{
			StudentDatas = new ReadOnlyObservableCollection<StudentData>(studentDatas);

			Query();
		}

		


		private void Query()
		{
			SQLHelper.Query<StudentData>("users").ForEach(x => studentDatas.Add(x));
		}
	}
}
